#ifndef SRCOMM3_DoorGame_h
#define SRCOMM3_DoorGame_h

#include <srcomm3/statusba.h>

struct DoorGame
{
    // classwide
    static Time startPlayTime;
    static string name, abbrev, version;
	static int nodeLock;

	static StatusBar* statusBar;

	static void Shutdown();
	static int  SetLockout();
	static void ReleaseLockout();

	// Door Game application
    DoorGame( string name, string abbrev, string version );
    ~DoorGame();

    // LocalParams returns true if the game should continue to run
    virtual bool LocalParams();
    // Run the game
    virtual void PlayGame() = 0;
    // Create a statusbar
    virtual StatusBar* MakeStatusBar();

    // Set up the modem with the door info from DOOR
    virtual void SetupModem();
    // Read lots of SRE-style resources
    virtual void StandardSetup();
    // Run() will set everything up and run the game
    virtual void Run();
};

#endif

